package test.ssoa.jbpm.manager;

import org.jbpm.api.Execution;
import org.jbpm.api.ProcessInstance;
import org.jbpm.pvm.internal.model.ExecutionImpl;
import org.jbpm.test.JbpmTestCase;

public class ForkTest extends JbpmTestCase {
	  protected String deploymentFork;
	  
	  protected void setUp() throws Exception {
		    super.setUp();
		    
		    //add user to database
		    identityService.createUser("testUser", "testUser", "testUser", "testUser@test.com");
		    
		    deploymentFork = repositoryService.createDeployment()
		    .addResourceFromClasspath("test/ssoa/jbpm/manager/ForkProcess.jpdl.xml").deploy();	    
		    
	  }
	  
	  protected void tearDown() throws Exception {	
			 //workflowManager.endAll();
			 identityService.deleteUser("testUser");
			 repositoryService.deleteDeploymentCascade(deploymentFork);			 	 
			 super.tearDown();		   
	  }

	  public void testForking()
	  {
		  ProcessInstance processInstance = executionService.startProcessInstanceByKey("ForkSubProcess");
		  String pid = processInstance.getId();	
		  
		  Execution mainExe = executionService.findExecutionById(pid);	  
		  
		 ((ExecutionImpl)mainExe).end(); //exception here		 
		  
	  }
}
